<template>
  <div>
    <h3>Create new user</h3>
    <el-row :gutter="3">
      <el-col :span="12">
        <el-input v-model="first_name" placeholder="Enter first name" />
        <span class="error" v-show="!validFirst_name"
          >Enter first name 3 to 255 symbols</span
        >
      </el-col>
      <el-col :span="12">
        <el-input v-model="last_name" placeholder="Enter last name" />
        <span class="error" v-show="!validLast_name"
          >Enter last name 3 to 255 symbols</span
        >
      </el-col>
    </el-row>

    <el-row :gutter="3">
      <el-col :span="12">
        <el-input v-model="email" placeholder="Enter email" />
        <span class="error" v-show="!validEmail">Enter valid email</span>
      </el-col>
      <el-col :span="12">
        <el-input
          v-model="password"
          show-password
          placeholder="Enter last_name"
        />
      </el-col>
    </el-row>

    <el-button :disabled="!validFields" @click="postUser">Save</el-button>
  </div>
</template>

<script>
  import userModelMixin from "./userModelMixin";

  export default {
    mixins: [userModelMixin],
    methods: {
      postUser() {
        this.axios
          .post("/user", {
            first_name: this.first_name,
            last_name: this.last_name,
            email: this.email,
            password: this.password,
          })
          .then((data) => {
            console.log("data", data);
            if (data.status == 200) {
              this.$router.push({ name: "Home" });
              this.$notify.success({
                title: "Success",
                message: "Successfully added user",
              });
            }
          })
          .catch((error) => {
            this.$notify.error({
              title: "Error",
              message: error.response.data,
            });
          });
      },
    },
  };
</script>

<style>
  .error {
    color: tomato;
  }

  .el-input {
    margin: 3px;
    padding: 5px;
  }
</style>